import axios from 'axios'
import { log } from './logger'

export function post (url, json, success, fail, contentType = 'FORM') {
  if (!json.account) json.account = global.localStorage.getItem('account') || ''
  if (!json.token) json.token = global.localStorage.getItem('token') || ''

  log(`POST URL: ${url}`, `POST JSON: ${JSON.stringify(json)}`)

  axios({
    method: 'POST',
    url: '/dispatcher',
    data: {
      method: 'POST',
      path: url,
      data: json,
      contentType: contentType
    }
  }).then(function (resp) {
    if (resp.data.errcode === 0) {
      success(resp.data.data)
    } else {
      fail(resp.data.errmsg)
    }
  })
  .catch(function (err) {
    console.log(err)
  })
}

export function get (url, success, fail) {
  let account = global.localStorage.getItem('account') || ''
  let token = global.localStorage.getItem('token') || ''

  if (account && !/account=/gi.test(url)) {
    let prefix = /\?/gi.test(url) ? '&' : '?'
    url += `${prefix}account=${account}`
  }
  if (token && !/token=/gi.test(url)) {
    let prefix = /\?/gi.test(url) ? '&' : '?'
    url += `${prefix}token=${token}`
  }

  log(`GET URL: ${url}`)

  axios({
    method: 'POST',
    url: '/dispatcher',
    data: {
      method: 'GET',
      path: url,
      data: {}
    }
  }).then(function (resp) {
    if (resp.data.errcode === 0) {
      success(resp.data.data)
    } else {
      fail(resp.data.errmsg)
    }
  })
  .catch(function (err) {
    console.log(err)
  })
}
